#include <stdio.h>
#define n1  2048
#define n2  2048
#define n  n1*n2
#define f48  348         // max join_do_flat / flat file is 348
FILE  *fp,*f[f48],*fp1;		
char  head[72][80];
float a[n2*n1],bb[f48],fm[f48];
short ccd[n2*n1];
int   ip;
float bias[n2*n1],bias0;

main(int ac,char **av)
{
  char t[80]; int k;
  if(ac<2){
  printf("\n\t\t ******** 1key (max 348 fits)*********\n");
  printf("\n\t raw_flat_data - bias ---> flat.fit  mode = median\n");
  printf("\n\t Usage:  lc1key !            jiang  20140103,0125\n\n");
  printf(" 1. automatic processing pipeline1 job, not answer any question.\n"); 
  printf(" 2. create a new directory, empty.\n");
  printf(" 3. copy raw_flat_files (with bias.fit)  to this directory\n");
  printf(" 4. in this directory, type command: lc1key !\n");
  printf(" 5. flat.fit is the result\n\n");
  exit(0);
  } 
  sprintf(t,"bias.fit");
  fp=fopen(t,"rb"); if(!fp){
    sprintf(t,"../bias/bias.fit");
    fp=fopen(t,"rb");
    if(!fp){printf("\n\tbias.fit not found! (also in ../bias)\n"); exit(0); }
  }
  fread(head,72,80,fp); fread(bias,n,4,fp); fclose(fp); swap4(bias,n*4);
  k=indexpos(head,"SKYADU  ",72);
  if(k==72){ printf("%s not our fitsfile\n",t); exit(0); }
  sscanf(&head[k][20],"%f",&bias0);
  job_b4(); 
  work(a);
  system("mv lc1key.fit flat.fit"); 
  printf("\toutput file: flat.fit   OK !\n");
} 

job_b4()
{
  int j,k; char a[60]; float x,s;
  system("ls FLAT*.fit >1.1");
  fp=fopen("1.1","r"); ip=0;
l10:
  fgets(a,60,fp); if(feof(fp))goto l20;
  a[strlen(a)-1]=0;
  fp1=fopen(a,"rb"); fread(head,72,80,fp1); fread(ccd,n,2,fp1); fclose(fp1);
  swap2(ccd,n*2); k=0;
  for(j=0;j<n;j++){
    ccd[j]+=32768; ccd[j]-=bias0; if(ccd[j]>0 && ccd[j]<32768)ccd[k++]=ccd[j];
  }
  white_black(ccd,1,k,&x,&s);  fm[ip]=x;

  f[ip]=fopen(a,"rb"); fread(head,72,80,f[ip]); 
  printf("%3d: %s %9.2f\n",++ip,a,x);
  k=indexpos(head,"BITPIX  ",72);
  sscanf(&head[k][20],"%d",&j); if(j!=16){ printf("\tnot a raw file\n");
                                           exit(0); }
  k=indexpos(head,"NAXIS1  ",72);
  sscanf(&head[k][20],"%d",&j); if(j!=n1){ printf("\tnot a 50bin\n");
                                           exit(0); }
  sscanf(&head[k+1][20],"%d",&j); if(j!=n2){ printf("\tnot a 50bin\n");
                                           exit(0); }
  k=indexpos(head,"CCDTYPE ",72);
  if(head[k][11]!='F'){ printf("\tnot a flat file\n"); exit(0); }
  goto l10;
l20:
  fclose(fp);  
  if(ip<4){ printf("less FLAT*.fit, at lest >= 4\n"); exit(0); }
}

work(float *a)
{
  float x; int i,j,k,l,m=0,mm;
  for(i=0;i<58;i++)printf("-"); printf("\n");
  for(i=0;i<n2;i++){
    if(i%99==0){ printf("."); fflush(stdout); }
    for(j=0;j<ip;j++){ k=j*n1; fread(&ccd[k],2,n1,f[j]); }
    swap2(ccd,n1*ip*2);		
    for(j=0;j<n1;j++){
      l=j; for(k=0;k<ip;k++){  x=ccd[l]+32768; x-=bias[l];
                               x/=fm[k];
                               bb[k]=x;
                               l+=n1; }
      sup_median(bb,ip,&x);
      a[m++] =x;
    }
  } for(j=0;j<ip;j++)fclose(f[j]); 

  k=indexpos(head,"END     ",72);
  head[k][0]=head[k][1]=head[k][2]=32;
  for(j= 5;j<=6;j++)for(i=0;i<80;i++)head[j][i]=32;
  head[71][0]='E'; head[71][1]='N'; head[71][2]='D'; 
  strncpy(&head[1][27],"-32",3);	/* real*4 */
  sprintf(head[k],"DOMEFLAT= %20d / flatfiles, _median",ip); head[k][51]=32;
  fp=fopen("lc1key.fit","wb");
  fwrite(head,72,80,fp); swap4(a,n*4); fwrite(a,4,n,fp);
  fclose(fp);
}
	
sup_median(a,nn,medi)
float *a,*medi; int nn;
{
  float x; int i,j;
  for(i=0;i<nn-1;i++)for(j=i+1;j<nn;j++)if( *(a+i) > *(a+j)){
    x= *(a+i); *(a+i) = *(a+j); *(a+j)=x;
  } i=nn/2;
  *medi = (i+i==nn) ? (*(a+i) + *(a+i-1))*0.5 : *(a+i);
}
